{
 open String;;
 open Parser;;
open Printf;;
exception Eof;;
} 
let printable = ['!'-';''=''?'-'~']
let whitespace = ['\n''\r''\t'' ']
let number = ['0'-'9']+
let tagcontents = ['0'-'9''a'-'z''A'-'Z']+
let tags = "B" | "EM" | "S" | "TT" | "U" | "PL" | "I" | ['0'-'9'] | 
['r''g''b''c''m''y''k''w']
    rule beginLex = parse
| printable+ { STRING (Lexing.lexeme lexbuf) }
| whitespace+ { WHITESPACE (Lexing.lexeme lexbuf) }
| "<" tags ">" { O_TAG (let s = (Lexing.lexeme lexbuf) in get s 1) }
| "</" tags ">" { C_TAG (let s = (Lexing.lexeme lexbuf) in get s 2) }
| eof { EOF }

