%{
open Block;;
%}

%token <char> O_TAG, C_TAG
%token <string> WHITESPACE
%token <string> STRING
%token EOF

%start document
%type <'a list> document

%%

document :
| EOF { [] }
| blocklist EOF { $1 }

blocklist:
| tag { [$1] }
| tag blocklist { $1 :: $2 }
| text { [ $1 ] }
| text blocklist { $1 :: $2 }

text :
| STRING { Text $1 }
| WHITESPACE { Space $1 }

tag:
| opentag blocklist closetag { assert($1=$3); Block ($1,$2) }
| opentag closetag { assert($1=$2); Block ($1, []) }

opentag:
| O_TAG { $1 }

closetag:
| C_TAG { $1 }

%%

;;
